{ ******* OpenSSL Cu Copyright 2018 Mam ******* }
unit MamOpenSSL;

interface
uses System.SysUtils,IdSSLOpenSSLHeaders,system.NetEncoding,WinApi.Windows;

//AES-128-ECBÍ(Íf[^,L[(16oCg) out:Íf[^)
function MamEncAes128Ecb(
  DecData,Key:TBytes;out EncData:TBytes):Boolean;overload;
//AES-128-ECBÍ(Íf[^,L[(16oCg) out:Íf[^BASE64)
function MamEncAes128Ecb(
  DecData,Key:TBytes;out EncDataBase64:String):Boolean;overload;

//AES-192-ECBÍ(Íf[^,L[(24oCg) out:Íf[^)
function MamEncAes192Ecb(
  DecData,Key:TBytes;out EncData:TBytes):Boolean;overload;
//AES-192-ECBÍ(Íf[^,L[(24oCg) out:Íf[^BASE64)
function MamEncAes192Ecb(
  DecData,Key:TBytes;out EncDataBase64:String):Boolean;overload;

//AES-256-ECBÍ(Íf[^,L[(32oCg) out:Íf[^)
function MamEncAes256Ecb(
  DecData,Key:TBytes;out EncData:TBytes):Boolean;overload;
//AES-256-ECBÍ(Íf[^,L[(32oCg) out:Íf[^BASE64)
function MamEncAes256Ecb(
  DecData,Key:TBytes;out EncDataBase64:String):Boolean;overload;


//AES-128-ECB(out:ꂽf[^,L[(16oCg) ,Íf[^)
function MamDecAes128Ecb(
  out DecData:TBytes;Key,EncData:TBytes):Boolean;overload;
//AES-128-ECB(out:ꂽf[^,L[(16oCg) ,Íf[^BASE64)
function MamDecAes128Ecb(
  out DecData:TBytes;Key:TBytes;EncDataBase64:String):Boolean;overload;

//AES-192-ECB(out:ꂽf[^,L[(24oCg) ,Íf[^)
function MamDecAes192Ecb(
  out DecData:TBytes;Key,EncData:TBytes):Boolean;overload;
//AES-192-ECB(out:ꂽf[^,L[(24oCg) ,Íf[^BASE64)
function MamDecAes192Ecb(
  out DecData:TBytes;Key:TBytes;EncDataBase64:String):Boolean;overload;

//AES-256-ECB(out:ꂽf[^,L[(32oCg) ,Íf[^)
function MamDecAes256Ecb(
  out DecData:TBytes;Key,EncData:TBytes):Boolean;overload;
//AES-256-ECB(out:ꂽf[^,L[(32oCg) ,Íf[^BASE64)
function MamDecAes256Ecb(
  out DecData:TBytes;Key:TBytes;EncDataBase64:String):Boolean;overload;


//AES-128-CBCÍ(Íf[^,L[(16oCg),xNg(16oCg) out:Íf[^)
function MamEncAes128Cbc(
  DecData,Key,Iv:TBytes;out EncData:TBytes):Boolean;overload;
//AES-128-CBCÍ(Íf[^,L[(16oCg),xNg(16oCg) out:Íf[^BASE64)
function MamEncAes128Cbc(
  DecData,Key,Iv:TBytes;out EncDataBase64:String):Boolean;overload;

//AES-192-CBCÍ(Íf[^,L[(24oCg),xNg(16oCg) out:Íf[^)
function MamEncAes192Cbc(
  DecData,Key,Iv:TBytes;out EncData:TBytes):Boolean;overload;
//AES-192-CBCÍ(Íf[^,L[(24oCg),xNg(16oCg) out:Íf[^BASE64)
function MamEncAes192Cbc(
  DecData,Key,Iv:TBytes;out EncDataBase64:String):Boolean;overload;

//AES-256-CBCÍ(Íf[^,L[(32oCg),xNg(16oCg) out:Íf[^)
function MamEncAes256Cbc(
  DecData,Key,Iv:TBytes;out EncData:TBytes):Boolean;overload;
//AES-256-CBCÍ(Íf[^,L[(32oCg),xNg(16oCg) out:Íf[^BASE64)
function MamEncAes256Cbc(
  DecData,Key,Iv:TBytes;out EncDataBase64:String):Boolean;overload;


//AES-128-CBC(out:ꂽf[^,L[(16oCg),xNg(16oCg) ,Íf[^)
function MamDecAes128Cbc(
  out DecData:TBytes;Key,Iv,EncData:TBytes):Boolean;overload;
//AES-128-CBC(out:ꂽf[^,L[(16oCg),xNg(16oCg) ,Íf[^BASE64)
function MamDecAes128Cbc(
  out DecData:TBytes;Key,Iv:TBytes;EncDataBase64:String):Boolean;overload;

//AES-192-CBC(out:ꂽf[^,L[(24oCg),xNg(16oCg) ,Íf[^)
function MamDecAes192Cbc(
  out DecData:TBytes;Key,Iv,EncData:TBytes):Boolean;overload;
//AES-192-CBC(out:ꂽf[^,L[(24oCg),xNg(16oCg) ,Íf[^BASE64)
function MamDecAes192Cbc(
  out DecData:TBytes;Key,Iv:TBytes;EncDataBase64:String):Boolean;overload;

//AES-256-CBC(out:ꂽf[^,L[(32oCg),xNg(16oCg) ,Íf[^)
function MamDecAes256Cbc(
  out DecData:TBytes;Key,Iv,EncData:TBytes):Boolean;overload;
//AES-256-CBC(out:ꂽf[^,L[(32oCg),xNg(16oCg) ,Íf[^BASE64)
function MamDecAes256Cbc(
  out DecData:TBytes;Key,Iv:TBytes;EncDataBase64:String):Boolean;overload;


implementation

function MamEncAes128Ecb(
  DecData,Key:TBytes;out EncData:TBytes):Boolean;overload;
var ctx:PEVP_CIPHER_CTX;
    Encl,Padl:integer;
    l:integer;
begin
  Result:=false;
  if not load then exit;
  if length(Key)<16 then
  begin
    l:=length(Key);
    SetLength(Key,16);
    ZeroMemory(@Key[l],16-l);
  end;
  ctx:=EVP_CIPHER_CTX_new();
  EVP_CIPHER_CTX_init(ctx);
  EVP_EncryptInit_ex(ctx,EVP_aes_128_ecb,nil,@key[0],nil);
  setLength(EncData, (length(DecData) div 16+1)*16);
  EVP_EncryptUpdate(ctx,@EncData[0],@Encl,@DecData[0],length(DecData));
  EVP_EncryptFinal_ex(ctx,@EncData[Encl],@Padl);
  EVP_CIPHER_CTX_free(ctx);
  SetLength(EncData,Encl+Padl);
  unload;
  Result:=true;
end;
function MamEncAes128Ecb(
  DecData,Key:TBytes;out EncDataBase64:String):Boolean;overload;
var EncData:TBytes;
begin
  result:=MamEncAes128Ecb(DecData,Key,EncData);
  EncData:=TNetEncoding.Base64.Encode(EncData);
  EncDataBase64:=TEncoding.ASCII.GetString(EncData);
end;

function MamEncAes192Ecb(
  DecData,Key:TBytes;out EncData:TBytes):Boolean;overload;
var ctx:PEVP_CIPHER_CTX;
    Encl,Padl:integer;
    l:integer;
begin
  Result:=false;
  if not load then exit;
  if length(Key)<24 then
  begin
    l:=length(Key);
    SetLength(Key,24);
    ZeroMemory(@Key[l],24-l);
  end;
  ctx:=EVP_CIPHER_CTX_new();
  EVP_CIPHER_CTX_init(ctx);
  EVP_EncryptInit_ex(ctx,EVP_aes_192_ecb,nil,@key[0],nil);
  setLength(EncData, (length(DecData) div 16+1)*16);
  EVP_EncryptUpdate(ctx,@EncData[0],@Encl,@DecData[0],length(DecData));
  EVP_EncryptFinal_ex(ctx,@EncData[Encl],@Padl);
  EVP_CIPHER_CTX_free(ctx);
  SetLength(EncData,Encl+Padl);
  unload;
  Result:=true;
end;
function MamEncAes192Ecb(
  DecData,Key:TBytes;out EncDataBase64:String):Boolean;overload;
var EncData:TBytes;
begin
  result:=MamEncAes192Ecb(DecData,Key,EncData);
  EncData:=TNetEncoding.Base64.Encode(EncData);
  EncDataBase64:=TEncoding.ASCII.GetString(EncData);
end;

function MamEncAes256Ecb(DecData,Key:TBytes;
  out EncData:TBytes):Boolean;overload;
var ctx:PEVP_CIPHER_CTX;
    Encl,Padl:integer;
    l:integer;
begin
  Result:=false;
  if not load then exit;
  if length(Key)<32 then
  begin
    l:=length(Key);
    SetLength(Key,32);
    ZeroMemory(@Key[l],32-l);
  end;
  ctx:=EVP_CIPHER_CTX_new();
  EVP_CIPHER_CTX_init(ctx);
  EVP_EncryptInit_ex(ctx,EVP_aes_256_ecb,nil,@key[0],nil);
  setLength(EncData, (length(DecData) div 16+1)*16);
  EVP_EncryptUpdate(ctx,@EncData[0],@Encl,@DecData[0],length(DecData));
  EVP_EncryptFinal_ex(ctx,@EncData[Encl],@Padl);
  EVP_CIPHER_CTX_free(ctx);
  SetLength(EncData,Encl+Padl);
  unload;
  Result:=true;
end;
function MamEncAes256Ecb(DecData,Key:TBytes;
  out EncDataBase64:String):Boolean;overload;
var EncData:TBytes;
begin
  result:=MamEncAes256Ecb(DecData,Key,EncData);
  EncData:=TNetEncoding.Base64.Encode(EncData);
  EncDataBase64:=TEncoding.ASCII.GetString(EncData);
end;




function MamDecAes128Ecb(
  out DecData:TBytes;Key,EncData:TBytes):Boolean;overload;
var ctx:PEVP_CIPHER_CTX;
    Decl,Padl:Integer;
    l:integer;
begin
  Result:=false;
  if not load then exit;
  if length(Key)<16 then
  begin
    l:=length(Key);
    SetLength(Key,16);
    ZeroMemory(@Key[l],16-l);
  end;
  ctx:=EVP_CIPHER_CTX_new();
  EVP_CIPHER_CTX_init(ctx);
  EVP_DecryptInit_ex(ctx,EVP_aes_128_ecb,nil,@key[0],nil);
  setLength(DecData,length(EncData));
  EVP_DecryptUpdate(ctx,@DecData[0],LongWord(pointer(@Decl)),
    @EncData[0],Length(EncData));
  EVP_DecryptFinal_ex(ctx,@DecData[Decl],LongWord(Pointer(@Padl)));
  setlength(DecData,Decl+Padl);
  unload;
  Result:=True;
end;
function MamDecAes128Ecb(
  out DecData:TBytes;Key:TBytes;EncDataBase64:String):Boolean;overload;
var EncData:TBytes;
begin
  EncData:=TEncoding.ASCII.GetBytes(EncDataBase64);
  EncData:=TNetEncoding.Base64.Decode(EncData);
  Result:=MamDecAes128Ecb(DecData,Key,EncData);
end;

function MamDecAes192Ecb(
  out DecData:TBytes;Key,EncData:TBytes):Boolean;overload;
var ctx:PEVP_CIPHER_CTX;
    Decl,Padl:Integer;
    l:integer;
begin
  Result:=false;
  if not load then exit;
  if length(Key)<24 then
  begin
    l:=length(Key);
    SetLength(Key,24);
    ZeroMemory(@Key[l],24-l);
  end;
  ctx:=EVP_CIPHER_CTX_new();
  EVP_CIPHER_CTX_init(ctx);
  EVP_DecryptInit_ex(ctx,EVP_aes_192_ecb,nil,@key[0],nil);
  setLength(DecData,length(EncData));
  EVP_DecryptUpdate(ctx,@DecData[0],LongWord(pointer(@Decl)),
    @EncData[0],Length(EncData));
  EVP_DecryptFinal_ex(ctx,@DecData[Decl],LongWord(Pointer(@Padl)));
  setlength(DecData,Decl+Padl);
  unload;
  Result:=True;
end;
function MamDecAes192Ecb(
  out DecData:TBytes;Key:TBytes;EncDataBase64:String):Boolean;overload;
var EncData:TBytes;
begin
  EncData:=TEncoding.ASCII.GetBytes(EncDataBase64);
  EncData:=TNetEncoding.Base64.Decode(EncData);
  Result:=MamDecAes192Ecb(DecData,Key,EncData);
end;

function MamDecAes256Ecb(
  out DecData:TBytes;Key,EncData:TBytes):Boolean;overload;
var ctx:PEVP_CIPHER_CTX;
    Decl,Padl:Integer;
    l:integer;
begin
  Result:=false;
  if not load then exit;
  if length(Key)<32 then
  begin
    l:=length(Key);
    SetLength(Key,32);
    ZeroMemory(@Key[l],32-l);
  end;
  ctx:=EVP_CIPHER_CTX_new();
  EVP_CIPHER_CTX_init(ctx);
  EVP_DecryptInit_ex(ctx,EVP_aes_256_ecb,nil,@key[0],nil);
  setLength(DecData,length(EncData));
  EVP_DecryptUpdate(ctx,@DecData[0],LongWord(pointer(@Decl)),
    @EncData[0],Length(EncData));
  EVP_DecryptFinal_ex(ctx,@DecData[Decl],LongWord(Pointer(@Padl)));
  setlength(DecData,Decl+Padl);
  unload;
  Result:=True;
end;
function MamDecAes256Ecb(
  out DecData:TBytes;Key:TBytes;EncDataBase64:String):Boolean;overload;
var EncData:TBytes;
begin
  EncData:=TEncoding.ASCII.GetBytes(EncDataBase64);
  EncData:=TNetEncoding.Base64.Decode(EncData);
  Result:=MamDecAes256Ecb(DecData,Key,EncData);
end;




function MamEncAes128Cbc(
  DecData,Key,Iv:TBytes;out EncData:TBytes):Boolean;overload;
var ctx:PEVP_CIPHER_CTX;
    Encl,Padl:integer;
    l:integer;
begin
  Result:=false;
  if not load then exit;
  if length(Key)<16 then
  begin
    l:=length(Key);
    SetLength(Key,16);
    ZeroMemory(@Key[l],16-l);
  end;
  if length(Iv)<16 then
  begin
    l:=length(Iv);
    SetLength(Iv,16);
    ZeroMemory(@Iv[l],16-l);
  end;
  ctx:=EVP_CIPHER_CTX_new();
  EVP_CIPHER_CTX_init(ctx);
  EVP_EncryptInit_ex(ctx,EVP_aes_128_cbc,nil,@key[0],@Iv[0]);
  setLength(EncData, (length(DecData) div 16+1)*16);
  EVP_EncryptUpdate(ctx,@EncData[0],@Encl,@DecData[0],length(DecData));
  EVP_EncryptFinal_ex(ctx,@EncData[Encl],@Padl);
  EVP_CIPHER_CTX_free(ctx);
  SetLength(EncData,Encl+Padl);
  unload;
  Result:=true;
end;
function MamEncAes128Cbc(
  DecData,Key,Iv:TBytes;out EncDataBase64:String):Boolean;overload;
var EncData:TBytes;
begin
  result:=MamEncAes128Cbc(DecData,Key,Iv,EncData);
  EncData:=TNetEncoding.Base64.Encode(EncData);
  EncDataBase64:=TEncoding.ASCII.GetString(EncData);
end;

function MamEncAes192Cbc(
  DecData,Key,Iv:TBytes;out EncData:TBytes):Boolean;overload;
var ctx:PEVP_CIPHER_CTX;
    Encl,Padl:integer;
    l:integer;
begin
  Result:=false;
  if not load then exit;
  if length(Key)<24 then
  begin
    l:=length(Key);
    SetLength(Key,24);
    ZeroMemory(@Key[l],24-l);
  end;
  if length(Iv)<16 then
  begin
    l:=length(Iv);
    SetLength(Iv,16);
    ZeroMemory(@Iv[l],16-l);
  end;
  ctx:=EVP_CIPHER_CTX_new();
  EVP_CIPHER_CTX_init(ctx);
  EVP_EncryptInit_ex(ctx,EVP_aes_192_cbc,nil,@key[0],@Iv[0]);
  setLength(EncData, (length(DecData) div 16+1)*16);
  EVP_EncryptUpdate(ctx,@EncData[0],@Encl,@DecData[0],length(DecData));
  EVP_EncryptFinal_ex(ctx,@EncData[Encl],@Padl);
  EVP_CIPHER_CTX_free(ctx);
  SetLength(EncData,Encl+Padl);
  unload;
  Result:=true;
end;
function MamEncAes192Cbc(
  DecData,Key,Iv:TBytes;out EncDataBase64:String):Boolean;overload;
var EncData:TBytes;
begin
  result:=MamEncAes192Cbc(DecData,Key,Iv,EncData);
  EncData:=TNetEncoding.Base64.Encode(EncData);
  EncDataBase64:=TEncoding.ASCII.GetString(EncData);
end;

function MamEncAes256Cbc(
  DecData,Key,Iv:TBytes;out EncData:TBytes):Boolean;overload;
var ctx:PEVP_CIPHER_CTX;
    Encl,Padl:integer;
    l:integer;
begin
  Result:=false;
  if not load then exit;
  if length(Key)<32 then
  begin
    l:=length(Key);
    SetLength(Key,32);
    ZeroMemory(@Key[l],32-l);
  end;
  if length(Iv)<16 then
  begin
    l:=length(Iv);
    SetLength(Iv,16);
    ZeroMemory(@Iv[l],16-l);
  end;
  ctx:=EVP_CIPHER_CTX_new();
  EVP_CIPHER_CTX_init(ctx);
  EVP_EncryptInit_ex(ctx,EVP_aes_256_cbc,nil,@key[0],@Iv[0]);
  setLength(EncData, (length(DecData) div 16+1)*16);
  EVP_EncryptUpdate(ctx,@EncData[0],@Encl,@DecData[0],length(DecData));
  EVP_EncryptFinal_ex(ctx,@EncData[Encl],@Padl);
  EVP_CIPHER_CTX_free(ctx);
  SetLength(EncData,Encl+Padl);
  unload;
  Result:=true;
end;
function MamEncAes256Cbc(
  DecData,Key,Iv:TBytes;out EncDataBase64:String):Boolean;overload;
var EncData:TBytes;
begin
  result:=MamEncAes256Cbc(DecData,Key,Iv,EncData);
  EncData:=TNetEncoding.Base64.Encode(EncData);
  EncDataBase64:=TEncoding.ASCII.GetString(EncData);
end;




function MamDecAes128Cbc(
  out DecData:TBytes;Key,Iv,EncData:TBytes):Boolean;overload;
var ctx:PEVP_CIPHER_CTX;
    Decl,Padl:Integer;
    l:integer;
begin
  Result:=false;
  if not load then exit;
  if length(Key)<16 then
  begin
    l:=length(Key);
    SetLength(Key,16);
    ZeroMemory(@Key[l],16-l);
  end;
  if length(Iv)<16 then
  begin
    l:=length(Iv);
    SetLength(Iv,16);
    ZeroMemory(@Iv[l],16-l);
  end;
  ctx:=EVP_CIPHER_CTX_new();
  EVP_CIPHER_CTX_init(ctx);
  EVP_DecryptInit_ex(ctx,EVP_aes_128_cbc,nil,@key[0],@Iv[0]);
  setLength(DecData,length(EncData));
  EVP_DecryptUpdate(ctx,@DecData[0],LongWord(pointer(@Decl)),
    @EncData[0],Length(EncData));
  EVP_DecryptFinal_ex(ctx,@DecData[Decl],LongWord(Pointer(@Padl)));
  setlength(DecData,Decl+Padl);
  unload;
  Result:=True;
end;
function MamDecAes128Cbc(
  out DecData:TBytes;Key,Iv:TBytes;EncDataBase64:String):Boolean;overload;
var EncData:TBytes;
begin
  EncData:=TEncoding.ASCII.GetBytes(EncDataBase64);
  EncData:=TNetEncoding.Base64.Decode(EncData);
  Result:=MamDecAes128Cbc(DecData,Key,Iv,EncData);
end;

function MamDecAes192Cbc(
  out DecData:TBytes;Key,Iv,EncData:TBytes):Boolean;overload;
var ctx:PEVP_CIPHER_CTX;
    Decl,Padl:Integer;
    l:integer;
begin
  Result:=false;
  if not load then exit;
  if length(Key)<24 then
  begin
    l:=length(Key);
    SetLength(Key,24);
    ZeroMemory(@Key[l],24-l);
  end;
  if length(Iv)<16 then
  begin
    l:=length(Iv);
    SetLength(Iv,16);
    ZeroMemory(@Iv[l],16-l);
  end;
  ctx:=EVP_CIPHER_CTX_new();
  EVP_CIPHER_CTX_init(ctx);
  EVP_DecryptInit_ex(ctx,EVP_aes_192_cbc,nil,@key[0],@Iv[0]);
  setLength(DecData,length(EncData));
  EVP_DecryptUpdate(ctx,@DecData[0],LongWord(pointer(@Decl)),
    @EncData[0],Length(EncData));
  EVP_DecryptFinal_ex(ctx,@DecData[Decl],LongWord(Pointer(@Padl)));
  setlength(DecData,Decl+Padl);
  unload;
  Result:=True;
end;
function MamDecAes192Cbc(
  out DecData:TBytes;Key,Iv:TBytes;EncDataBase64:String):Boolean;overload;
var EncData:TBytes;
begin
  EncData:=TEncoding.ASCII.GetBytes(EncDataBase64);
  EncData:=TNetEncoding.Base64.Decode(EncData);
  Result:=MamDecAes192Cbc(DecData,Key,Iv,EncData);
end;

function MamDecAes256Cbc(
  out DecData:TBytes;Key,Iv,EncData:TBytes):Boolean;overload;
var ctx:PEVP_CIPHER_CTX;
    Decl,Padl:Integer;
    l:integer;
begin
  Result:=false;
  if not load then exit;
  if length(Key)<32 then
  begin
    l:=length(Key);
    SetLength(Key,32);
    ZeroMemory(@Key[l],32-l);
  end;
  if length(Iv)<16 then
  begin
    l:=length(Iv);
    SetLength(Iv,16);
    ZeroMemory(@Iv[l],16-l);
  end;
  ctx:=EVP_CIPHER_CTX_new();
  EVP_CIPHER_CTX_init(ctx);
  EVP_DecryptInit_ex(ctx,EVP_aes_256_cbc,nil,@key[0],@Iv[0]);
  setLength(DecData,length(EncData));
  EVP_DecryptUpdate(ctx,@DecData[0],LongWord(pointer(@Decl)),
    @EncData[0],Length(EncData));
  EVP_DecryptFinal_ex(ctx,@DecData[Decl],LongWord(Pointer(@Padl)));
  setlength(DecData,Decl+Padl);
  unload;
  Result:=True;
end;
function MamDecAes256Cbc(
  out DecData:TBytes;Key,Iv:TBytes;EncDataBase64:String):Boolean;overload;
var EncData:TBytes;
begin
  EncData:=TEncoding.ASCII.GetBytes(EncDataBase64);
  EncData:=TNetEncoding.Base64.Decode(EncData);
  Result:=MamDecAes256Cbc(DecData,Key,Iv,EncData);
end;

end.
